/**
 * jQuery Cookie plugin
 *
 * Copyright (c) 2010 Klaus Hartl (stilbuero.de)
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 *
 */
jQuery.cookie=function(key,value,options){if(arguments.length>1&&String(value)!=="[object Object]"){options=jQuery.extend({},options);if(value===null||value===undefined){options.expires=-1;}
if(typeof options.expires==='number'){var days=options.expires,t=options.expires=new Date();t.setDate(t.getDate()+days);}
value=String(value);return(document.cookie=[encodeURIComponent(key),'=',options.raw?value:encodeURIComponent(value),options.expires?'; expires='+options.expires.toUTCString():'',options.path?'; path='+options.path:'',options.domain?'; domain='+options.domain:'',options.secure?'; secure':''].join(''));}
options=value||{};var result,decode=options.raw?function(s){return s;}:decodeURIComponent;return(result=new RegExp('(?:^|; )'+encodeURIComponent(key)+'=([^;]*)').exec(document.cookie))?decode(result[1]):null;};
(function($, window, document, undefined) {
    var $window = $(window);

    $.fn.lazyload = function(options) {
        var elements = this;
        var $container;
        var settings = {
            threshold       : 0,
            failure_limit   : 0,
            event           : "scroll",
            effect          : "show",
            container       : window,
            data_attribute  : "original",
            skip_invisible  : true,
            appear          : null,
            load            : null
        };

        function update() {
            var counter = 0;
            elements.each(function() {
                var $this = $(this);
                if (settings.skip_invisible && !$this.is(":visible")) {
                    return;
                }
                //阿远帮gb修改
                 $this.trigger("appear");
                 /*
                if ($.abovethetop(this, settings) ||
                    $.leftofbegin(this, settings)) {
                } else if (!$.belowthefold(this, settings) &&
                    !$.rightoffold(this, settings)) {
                        $this.trigger("appear");
                        counter = 0;
                } else {
                    if (++counter > settings.failure_limit) {
                        return false;
                    }
                }*/
            });

        }

        if(options) {
            /* Maintain BC for a couple of versions. */
            if (undefined !== options.failurelimit) {
                options.failure_limit = options.failurelimit; 
                delete options.failurelimit;
            }
            if (undefined !== options.effectspeed) {
                options.effect_speed = options.effectspeed; 
                delete options.effectspeed;
            }

            $.extend(settings, options);
        }

        /* Cache container as jQuery as object. */
        $container = (settings.container === undefined ||
                      settings.container === window) ? $window : $(settings.container);

        /* Fire one scroll event per scroll. Not one scroll event per image. */
        if (0 === settings.event.indexOf("scroll")) {
            $container.bind(settings.event, function(event) {
                return update();
            });
        }

        this.each(function() {
            var self = this;
            var $self = $(self);

            self.loaded = false;

            /* When appear is triggered load original image. */
            $self.one("appear", function() {
                if (!this.loaded) {
                    if (settings.appear) {
                        var elements_left = elements.length;
                        settings.appear.call(self, elements_left, settings);
                    }
                    $("<img />")
                        .bind("load", function() {
                            $self
                                .hide()
                                .attr("src", $self.data(settings.data_attribute))
                                [settings.effect](settings.effect_speed);
                            self.loaded = true;

                            /* Remove image from array so it is not looped next time. */
                            var temp = $.grep(elements, function(element) {
                                return !element.loaded;
                            });
                            elements = $(temp);

                            if (settings.load) {
                                var elements_left = elements.length;
                                settings.load.call(self, elements_left, settings);
                            }
                        })
                        .attr("src", $self.data(settings.data_attribute));
                }
            });

            /* When wanted event is triggered load original image */
            /* by triggering appear.                              */
            if (0 !== settings.event.indexOf("scroll")) {
                $self.bind(settings.event, function(event) {
                    if (!self.loaded) {
                        $self.trigger("appear");
                    }
                });
            }
        });

        /* Check if something appears when window is resized. */
        $window.bind("resize", function(event) {
            update();
        });
              
        /* With IOS5 force loading images when navigating with back button. */
        /* Non optimal workaround. */
        if ((/iphone|ipod|ipad.*os 5/gi).test(navigator.appVersion)) {
            $window.bind("pageshow", function(event) {
                if (event.originalEvent.persisted) {
                    elements.each(function() {
                        $(this).trigger("appear");
                    });
                }
            });
        }

        /* Force initial check if images should appear. */
        $(window).load(function() {
        	//console.log("update");
            update();
        });
        window.lazyloadUpdate = update;
        return this;
    };

    /* Convenience methods in jQuery namespace.           */
    /* Use as  $.belowthefold(element, {threshold : 100, container : window}) */

    $.belowthefold = function(element, settings) {
        var fold;
        
        if (settings.container === undefined || settings.container === window) {
            fold = $window.height() + $window.scrollTop();
        } else {
            fold = $(settings.container).offset().top + $(settings.container).height();
        }

        return fold <= $(element).offset().top - settings.threshold;
    };
    
    $.rightoffold = function(element, settings) {
        var fold;

        if (settings.container === undefined || settings.container === window) {
            fold = $window.width() + $window.scrollLeft();
        } else {
            fold = $(settings.container).offset().left + $(settings.container).width();
        }

        return fold <= $(element).offset().left - settings.threshold;
    };
        
    $.abovethetop = function(element, settings) {
        var fold;
        
        if (settings.container === undefined || settings.container === window) {
            fold = $window.scrollTop();
        } else {
            fold = $(settings.container).offset().top;
        }

        return fold >= $(element).offset().top + settings.threshold  + $(element).height();
    };
    
    $.leftofbegin = function(element, settings) {
        var fold;
        
        if (settings.container === undefined || settings.container === window) {
            fold = $window.scrollLeft();
        } else {
            fold = $(settings.container).offset().left;
        }

        return fold >= $(element).offset().left + settings.threshold + $(element).width();
    };

    $.inviewport = function(element, settings) {
         return !$.rightoffold(element, settings) && !$.leftofbegin(element, settings) &&
                !$.belowthefold(element, settings) && !$.abovethetop(element, settings);
     };

    /* Custom selectors for your convenience.   */
    /* Use as $("img:below-the-fold").something() or */
    /* $("img").filter(":below-the-fold").something() which is faster */

    $.extend($.expr[':'], {
        "below-the-fold" : function(a) { return $.belowthefold(a, {threshold : 0}); },
        "above-the-top"  : function(a) { return !$.belowthefold(a, {threshold : 0}); },
        "right-of-screen": function(a) { return $.rightoffold(a, {threshold : 0}); },
        "left-of-screen" : function(a) { return !$.rightoffold(a, {threshold : 0}); },
        "in-viewport"    : function(a) { return $.inviewport(a, {threshold : 0}); },
        /* Maintain BC for couple of versions. */
        "above-the-fold" : function(a) { return !$.belowthefold(a, {threshold : 0}); },
        "right-of-fold"  : function(a) { return $.rightoffold(a, {threshold : 0}); },
        "left-of-fold"   : function(a) { return !$.rightoffold(a, {threshold : 0}); }
    });

})(jQuery, window, document);

/*样式修正
*/
var SystemAnswersStyleAdjust = {
	wrap:function(contentString){
		if(contentString == undefined || contentString == "" || contentString == null)return "";
		var s1 = SystemAnswersStyleAdjust.filter(contentString),
			s2 = SystemAnswersStyleAdjust.wrapImgTags(s1),
			s3 = SystemAnswersStyleAdjust.wrapImgForLazyload(s2);
		return s3;
	},
	filter:function(contentString){
		var newContent = contentString.replace(/<blank>.*?<\/blank>|<blank.*?\/>/gi,"____");
		newContent = newContent.replace(/<img[^>]*?>/gi,function(str,target){
			var str1 = str.replace(/(width|height):[^";]*[;]*/gi,"");
			str1 = str1.replace(/(width|height)="[^"]*"/gi,"");
			//console.log(str1);
			return str1;
		});
		return newContent;
	},
	/*判断img标签字串是否是公式图片字串
	@param {string} +str:输入字串
	 */
	isFormulaImg:function(str){
		var m = str.match('class="frm"');
		if( m != null)return true;
		return false;
	},
	/*将img标签镶嵌在外层元素标签内，方便控制
	@param {string} +content: 字符串内容
	@return {string} : 封装后的字符串
	*/
	wrapImgTags:function(content){
		var newContent = content.replace(/(<img[^>]*>)/gi,function(str,target){
			var rep = '<div class="imgTagWrap" style="display:inline-block;">'+target+'</div>';
			return rep;
		});
		return newContent;
	},
	/*替换img src 的内容，做延迟加载之用
	@param {string} +content: 字符串内容
	@return {string} : 封装后的字符串
	*/
	wrapImgForLazyload:function(content){
		var newContent = content.replace(/<img.+?(src="([^"]*)")[^>]*?>/gi,function(str,target1,target2){
			var str1 = str.replace(target1,function(){
				var s = 'src="http://static.7wenta.com/mobile/wap/OCRRecommonPages/style/img_s/s-loading.png" data-original="'+target2+'"';
				return s; 
			});
			return str1;
		});
		return newContent;
	},
	/*重置图片大小
	*param jDom: img jquery对象
	*/
	resizeImgs:function(jDom,maxWidth){
   	   var imgWidth = jDom.width();
   	   var imgHeight = jDom.height();
   	   var newWidth = imgWidth,
   	   	   newHeight = imgHeight;
   	   //缩放宽度
   	   if(imgWidth >= maxWidth){ // 如果图片宽度超过预定宽度
	   	   	jDom.css({
		   	   	width:"100%",
		   	   	height:"auto"
		   	   });
   	   }
	},
	/*重置table大小
	*param jDom: cell jquery对象
	*/
	resizeTables:function(jDom,maxWidth){
	   var tableArr = jDom.find("table");
	   $.each(tableArr,function(idx,item){
	   	   var _item = $(item);
	   	   var tableWidth = _item.width();
	   	   var tableHeight = _item.height();
	   	   var newWidth = tableWidth,
	   	   	   newHeight = tableHeight;
	   	   //缩放宽度
	   	   if(tableWidth > maxWidth){
	   	   		newHeight = (tableHeight*maxWidth/tableWidth); 
		   	   	newWidth = maxWidth;
	   	   }
	   	   _item.css({
	   	   		// "overflow":"hidden",
	   	   		"width":newWidth+"px",
	   	   		"height":newHeight+"px"
	   	   });
	   });
	}
}

$(function(){
	var pageManage = {
		config:{},
		datas:{
		},
		utils:{
			isEmpty:function(obj){
				if(obj == " "||obj == ""||obj==undefined||obj==null)return true;
				else return false;
			},
			getValueWithKey:function(key){
				var reg = new RegExp("(^|&|\\?)"+key+"=([^&]*)(&|$)","i");
				var str = decodeURI(window.location.search);
				var res = str.match(reg);	
				if(res)return res[2];
				return null;
			},
			wrapImgUrl:function(url){
				var imgStr = '<img class="userImg" src="'+url+'"/>',
					img1 = SystemAnswersStyleAdjust.wrapImgForLazyload(imgStr);
				return img1;
			},
			openNativeUrl:function(url){
				var protocolIFrame = document.getElementById("clientIframeBridge");
				if(protocolIFrame != undefined && protocolIFrame != null){
					protocolIFrame.parentNode.removeChild(protocolIFrame);
				}
				protocolIFrame = document.createElement("iframe");
				protocolIFrame.style.display = "none";
				protocolIFrame.id = "clientIframeBridge";
				protocolIFrame.src = encodeURI(url);
				document.body.appendChild(protocolIFrame);
			}
		},
		init:function(){
			var self = this;
			self.render();
			self.evtBind();
		},
		initDataAndExec:function(){
			
		},
		evtBind:function(){
			var self = this;
			$(window).on("pageshow",function(){
				//console.log("pageshow");
				window.lazyloadUpdate();
			});
			$("body").on("click",".userImg",function(){
				var src = this.src;
				if(!src.match("s-loading.png"))self.browserBigPic(src);
			});
		},
		browserBigPic:function(src){
			//gb 修改
			window.nativeObject.browserBigPic(src);
		},
		renderUserAnswersCell:function(obj){
			var self = this;
			var html = '<div class="ocrWrp pr">\
									<div class="ocrQWrp">\
										<p class="t1">用户提问</p>\
										<div class="t2"></div>\
									</div>\
									<div class="ocrAnaWrp content-c">\
										<div class="line"></div>\
										<p class="t1">答案</p>\
										<div class="t2">\
										</div>\
									</div>\
						</div>';
			var $cell = $(html);
			var $qt = $cell.find(".ocrQWrp .t2");
			if(!self.utils.isEmpty(obj.wenTiContent)){
				$qt.html(SystemAnswersStyleAdjust.wrap(obj.wenTiContent));
			}
			if(!self.utils.isEmpty(obj.wenTiImgUrl)){
				$qt.append(self.utils.wrapImgUrl(obj.wenTiImgUrl));
			}
			var $ana = $cell.find(".ocrAnaWrp .t2");
			if(!self.utils.isEmpty(obj.daAnContent)){
				//$ana.append('<p>'+obj.daAnContent+'</p>');
				$ana.html(SystemAnswersStyleAdjust.wrap(obj.daAnContent));
			}
			if(!self.utils.isEmpty(obj.daAnImgUrl)){
				$ana.append(self.utils.wrapImgUrl(obj.daAnImgUrl));
			}
			return $cell;
		},
		renderSystemAnswersCell:function(obj){
			var self = this;
			var html = '<div class="ocrWrp pr">\
									<div class="ocrQWrp">\
										<p class="t1">题目</p>\
										<div class="t2"></div>\
									</div>\
									<div class="ocrAnaWrp content-c">\
										<div class="line"></div>\
										<p class="t1">答案</p>\
										<div class="t2">\
										</div>\
									</div>\
									<div class="ocrAnyWrp content-c">\
										<div class="line"></div>\
										<p class="t1">解析</p>\
										<div class="t2">\
										</div>\
									</div>\
									<div class="ocrKnaWrp content-c">\
										<div class="line"></div>\
										<p class="t1">知识点剖析</p>\
										<div class="t2">\
											<p class="t3">此题涉及的知识点包括：</p>\
										</div>\
									</div>\
								</div>';
			var $temp = $(html),
				qType = 0,
				options = null,
				answersStr = "",
				ocrContent = obj;
			$temp.find(".ocrQWrp .t2").html(SystemAnswersStyleAdjust.wrap(ocrContent.question));
			qType = ocrContent.type;
			options = ocrContent.options;
			if(qType == 0 && options){ // 选择题
				var $andoc = $('<div class="optionsWrp"></div>');
				for (var j = 0; j < options.length; j++){// 答案选项 布局构造
					var p = $('<div class="option"></div>');
					var opt = String.fromCharCode(j+65);
					var h = '<span class="opt">'+opt+'.&nbsp;' +'</span>';				
					var _optC = SystemAnswersStyleAdjust.wrap(options[j]),
						h = h + _optC;
					p.append(h);
					$andoc.append(p);
				}
				$temp.find(".ocrQWrp .t2").append($andoc);
			}
			
			if(!self.utils.isEmpty(ocrContent.answers)){ // 是否存在答案
				answersStr = "";
				for(var k = 0; k < ocrContent.answers.length; k++){
					answersStr += SystemAnswersStyleAdjust.wrap(ocrContent.answers[k]);
				}
				$temp.find(".ocrAnaWrp .t2").html(answersStr);
			}else{
				$temp.find(".ocrAnaWrp").css("display","none");
			}

			if(!self.utils.isEmpty(ocrContent.analysis)){ // 是否存在解析
				$temp.find(".ocrAnyWrp .t2").html(SystemAnswersStyleAdjust.wrap(ocrContent.analysis));
			}else{
				$temp.find(".ocrAnyWrp").css("display","none");
			}
			
			if(!self.utils.isEmpty(ocrContent.knowledges)){ // 是否存在知识点
				var aknow = '<div class="knaOptWrp">\
								<div class="kna-opt fbox-lc">\
									<p class="kna-star"></p>\
									<p class="kna-knows t4">坐标轴定义</p>\
								</div>\
								<div class="kna-opt-content t5">\
								</div>\
							</div>';
				var $aknow,aknowData;
				for(var i = 0; i <  ocrContent.knowledges.length; i++){
					$aknow = $(aknow);
					aknowData = ocrContent.knowledges[i];
					$aknow.find(".kna-knows").text(aknowData.name);
					$aknow.find(".kna-opt-content").html(SystemAnswersStyleAdjust.wrap(aknowData.analyse));
					$temp.find(".ocrKnaWrp .t2").append($aknow);
				}
			}else{
				$temp.find(".ocrKnaWrp").css("display","none");
			}
			return $temp;
		},
		render:function(){
			var self = this;
			var $mainFrame = $(".mainWrp");
			var data = window._OCRAnswerContent.value;
			var answerType = data.type;
			var $cell;
			if(answerType == 0){
				$cell = self.renderSystemAnswersCell(data.data);
			}else if(answerType == 1){
				$cell = self.renderUserAnswersCell(data.data);
			}else {
				return;
			}
			$mainFrame.append($cell);
			var opts = {
				load:function(){
					var $img = $(this),
						maxWidth = $(window).width()*0.9;
					SystemAnswersStyleAdjust.resizeImgs($img,maxWidth);
				},
				error:function(){
				}
			};
			$(".imgTagWrap img,.qImgWrp img,.userImg").lazyload(opts);
			setTimeout(function(){
				SystemAnswersStyleAdjust.resizeTables($mainFrame,$(window).width()*0.9);
				window.lazyloadUpdate();
			},500);
		}
	};
	window.OCRPageManage = pageManage;
	//pageManage.init();
	//gb 修改
	window.nativeObject.loadData();
});



