;(function($){
	$.wtBox = function(opts){
		var self = this;
		var _defaults = {
			parent : $("body"),
			type: 0,
			cnt : "作业问题，去问他~",
			wholeCnt : '',
			title : "问他小提示",
			sureTxt : "确定",
			cancelTxt : "取消",
			sureClose : true,
			iclass : "wtbox",
			overlay : true,
			xwIcon : true,
			width :　'auto',
			backClose : false,
			sure : function(elem){},
			cancel : function(elem){},
			close : function(elem){},
			after : function(elem){}
		};
		self.settings = $.extend({},_defaults,opts);

		var boxTemplate = '<div id="wtBoxWrp">'
								+(self.settings.overlay?'<div id="wtBoxOverlay" style="z-index:100;width: 100%;height: auto;background: #000;opacity: 0.5;position: absolute;left: 0px;top: 0px;"></div>':'')
								+'<div id="wtBoxContainer" style="z-index:101;width: 100%;position: fixed;left: 0px;top: 0px;display: -webkit-box;-webkit-box-orient: horizontal;-webkit-box-pack: center;-webkit-box-align: center;">'
								+'<div id="wtBox" style="z-index:102;" class="wtBox '+ self.settings.iclass +'">'
									+(self.settings.wholeCnt?self.settings.wholeCnt:'<div class="wtbox_tt">'
										+'<div class="box_cnt">'
											+'<div class="box_title">'+ self.settings.title +'</div>'
											+'<a class="box_close box_btn" data-btn="close" href="###"></a>'
										+'</div>'
									+'</div>'
									+'<div class="wtbox_bd">'
										+'<div class="box_bd_cnt">'+ self.settings.cnt +'</div>'
										+'<div class="box_ft_cnt">'
											+(self.settings.sureTxt == ""?'':'<div data-btn="sure" class="sureBtn box_btn">'+ self.settings.sureTxt +'</div>')
											+(self.settings.cancelTxt == ""?'':'<div data-btn="cancel" class="cancelBtn box_btn">'+ self.settings.cancelTxt +'</div>')
										+'</div>'
									+'</div>'
									+(!self.settings.xwIcon?'':'<div class="wtXWIcon"></div>'))
								+'</div>'
								+'</div>'
							+'</div>';
		var $box = $(boxTemplate).appendTo(self.settings.parent);
		var $wtBox = $box.find("#wtBox");
		var $wtBoxOverlay = $box.find("#wtBoxOverlay");
		if (self.settings.width != 'auto') {
			$wtBox.css({width : self.settings.width});
		};
		
		$wtBoxOverlay.css({height : $(document).height()});
		
		$box.find('#wtBoxContainer').css({height : $(window).height()});

		$(window).resize(function(){
			$box.find('#wtBoxContainer').css({height : $(window).height()});
		});

		$box.find(".box_btn").click(function(){
			var $this = $(this);
			var dataBtn = $this.data("btn");
			if (dataBtn == "cancel" || dataBtn == "close") {
				close();
			};
			if (self.settings.sureClose && dataBtn == "sure") {
				close();
			};
			self.settings[dataBtn]&&self.settings[dataBtn]($box);
			return false;
		});
		$('#wtBoxOverlay,#wtBoxContainer').click(function(){
			if (getPlatform() == 'android' || self.settings.backClose) {
				close();
			};
		});
		$wtBox.click(function(e){
			e.stopPropagation();
			e.preventDefault();
		});
		self.settings.after&&self.settings.after($box);
		window.pushPageStack && pushPageStack({name:'wtBox',elem:$box});

		function close(){
			if (window.popPageStack) {
				popPageStack()
			}else{
				$box.remove();
			}
		}
		function getPlatform() {
			var userAgent = (navigator.userAgent).toLowerCase(),
				agentArr = userAgent.split("_");
			var platform = userAgent.substr(0, 7),
				platform1 = userAgent.substr(0, 3);
			if (platform == "android") {
				return "android";
			}
			if (platform1 == "ios") {
				return "ios";
			}
			return "ios";
		}
	};
})(jQuery);