if (typeof Publisher == 'undefined') {
	var Publisher = {
		_o : $({}),
		//添加监听者
		listen : function(ev,func){
			this._o.bind(ev,function(){
				//屏蔽掉jQuery默认的第一个event对象参数
				func.apply(this, [].slice.call(arguments,1));
			});
		},
		//发布事件&数据
		fire : function(){
			this._o.trigger.apply(this._o,arguments);
		},
		//移除监听
		removeListen : function(ev){
			this._o.unbind(ev);
		}
	};
};

var wentaUtil = {
	template : function(str, data, regexp) {
	    return str.replace(regexp || /\${([^{}]*)}/g, function (str, p1) {
	        if(data[p1] || data[p1] == 0){
        		return data[p1].toString();
        	}else{
        		return '';
        	}
	    });
	},
	isDebug : function(){
		var search = window.location.search;
		var isDebug = wentaUtil.getArgMapper(search.substr(1)).isDebug;
		if (isDebug == 'true') {
			return true;
		}else{
			return false;
		}
	},
	/*
	获取url参数
	var search = window.location.search.substring(1);
	var argMapper = getArgMapper(search,'&','=');
	*/
	getArgMapper : function(str,sp1,sp2) {
	    var obj = {};
	    str = str || window.location.search.substr(1);
	    sp1 = sp1 || '&';
	    sp2 = sp2 || '=';
	    var args = str.toString().split(sp1);
	    for (var i = 0; i < args.length; i++) {
	        var arg = args[i].split(sp2);
	        obj[arg[0]] = arg[1];
	    };
	    return obj;
	},
	getLinkPlat : function(){
		var href = window.location.href;
		var _href = href.split('?')[0];
		var index1 = _href.lastIndexOf('_');
		var index2 = _href.lastIndexOf('.');
		return _href.substring(index1+1, index2);
	}
}

;var MobileAgent = (function(){
	var userAgent = (navigator.userAgent).toLowerCase(),
		agentArr = userAgent.split("_");
	/*
	 *该函数适用于自己问他定制的user-agent，对于默认user-agent的判断，请使用 getPlatformNormal 方法
	 */
	function _getPlatform(){
		var platform = userAgent.substr(0,7),
			platform1 = userAgent.substr(0,3);
		if(platform == "android"){return "android";}
		if(platform1 == "ios"){return "ios";}
		return null;
	}
	/*
	 *该函数获取问他app的版本号，老版本的Ios版问他app没有定制user-agent，则默认返回版本号 6
	 */
	function _getVersion(){
		if(null == _getPlatform()) return 6;
		return agentArr[2];
	}
	return {
		getPlatform:_getPlatform,/* 获取平台 return "ios" or "android" or null*/
		getVersion:_getVersion,  /* 获取版本号 return int*/
	}
})();


var cordovaDebug = {
	isDebug : function(){
		return wentaUtil.isDebug();
	},
	getImg : function(src,suc,fail){
		if (cordovaDebug.isDebug()) {
			suc&&suc(src);
		}else{
			navigator.http.image(src,function(data){
	    		suc&&suc(data);
	    	});
		}
	},
	getJSON : function(url,suc,fail){
		if (cordovaDebug.isDebug()) {
			return $.get(url,function(data){
				suc&&suc(data);
			});
		}else{
			var dtd = $.Deferred();//在函数内部，新建一个Deferred对象
			navigator.http.getJSON(url,60*5,function(data){
				suc&&suc(data);
				dtd.resolve(); //已处理
			},function(data){
				dtd.reject(); //已拒绝
				fail&&fail(data);
			});
			return dtd.promise(); //返回promise对象
		}
	}
};

document.addEventListener("deviceready", function(){

	// 兼容android isPageEnd公用的Bug，理应每个页面用完就销毁，但是现在一个页面的值会被另一个页面用到。
	// 所以现在只能每个页面重设一下isPageEnd值为true
	navigator.dataTransfer.push(DataTransferOption.DataTransferPushTarget[1], {
		isPageEnd : true
	}, function(data) {
        // alert(data);
    }, function(message) {
        alert(message); // 输出失败消息。
    });
    
}, false);