﻿var WENTA_VERSION = MobileAgent.getVersion();

var xsTASK = {
	viewMapper: {
		101 : {vId : 0},
		102 : {vId : 1},
		103 : {vId : 4},
		105 : {vId : 3},
		108 : {vId : 2}, 109 : {vId : 2}, 110 : {vId : 2}, 111 : {vId : 2}, 
		112 : {vId : 6}, 113 : {vId : 6}, 114 : {vId : 6},
		'112_ndr' : {vId : 7}, '113_ndr' : {vId : 7}, '114_ndr' : {vId : 7},
		115 : {vId : 8}, 
		116 : {vId : 5,param : {tag : 1}}, 117 : {vId : 5,param : {tag : 2}},
		118 : ((MobileAgent.getPlatform() == 'android' && WENTA_VERSION < 25) || (MobileAgent.getPlatform() == 'ios' && WENTA_VERSION < 16))?'update':{vId : 1}
	},
	DailyMapper : { //因为加入了排序，所以这个列表要和后端返回的每日任务列表一一对应
		'8' : {vId : 2, dcId : 'DAILY_TASK_ADOPT', rank : 3,latest : true},
		'9' : {vId : 5, dcId : 'DAILY_TASK_INVITE', rank : 5,latest : true},
		'10' : {vId : 2, dcId : 'DAILY_TASK_ANSWER', rank : 2,latest : true},
		'11' : {vId : 21, dcId : 'DAILY_TASK_ECHAT', rank : 1,latest : true},
		'12' : {vId : 20, dcId : 'DAILY_TASK_SHARE_WENTA', rank : 4,latest : ((MobileAgent.getPlatform() == 'android' && WENTA_VERSION > 35) || (MobileAgent.getPlatform() == 'ios' && WENTA_VERSION > 26))},
		'13' : {vId : null, dcId : 'DAILY_TASK_SIGN_IN', rank : 0,latest : true}
	},
	init : function(){
		navigator.dataTransfer.push(DataTransferOption.DataTransferPushTarget[2], {
			show : true,
			content : ['我的任务']
		}, function(data) {			
		}, function(message) {
	        alert(message); // 输出失败消息。
	    });
		xsTASK.getDaren();
		xsTASK.eventBind();
	},
	getDaren : function(){
		var actionUrl = 'http://www.7wenta.com/mobile/myinfo.json';
		cordovaDebug.getJSON(actionUrl,function(data){
			if (data.result.resultCode.code == 0) {
				xsTASK.isDaren = data.result.value.isStar;
				xsTASK.getxinshouTask();
			};
		},function(){
			$('.loadingWrp').html('网络异常，请查看网络是否连接');
			$('.loadingWrp').click(function(){
				window.location.reload();
			});
		});
	},
	getxinshouTask: function() {
		var actionUrl = 'http://www.7wenta.com/mobile/wap/getMyXinshouTasks.json';
		cordovaDebug.getJSON(actionUrl, function(data) {
			if (data.resultCode.code == 0) {
				var template = '<div class="main">\
									<div class="xsBlock dailyTask">\
										<div class="title">每日任务</div>\
										<div class="cnt">${dailyTask}</div>\
									</div>\
									<div class="xsBlock growTask">\
										<div class="title">成长任务</div>\
										<div class="cnt">${growTask}</div>\
									</div>\
								</div>';
				var obj = {
					dailyTask : xsTASK.renderDailyTask(data.dailyTask),
					growTask : xsTASK.renderXinshouTask(data.xinshouTask)
				};
				
				$('.innerBody').html(wentaUtil.template(template, obj))
			};
		});
	},
	renderXinshouTask: function(data){
		var liTemplate = '<li class="clearfix xinshou_${finished} ${hide} task_${taskId}" taskId="${taskId}" ontouchstart="return true">\
								<div class="l">\
									<div class="itm icon"></div>\
									<div class="itm name">${taskName}</div>\
									<div class="itm wendou">+${awardWenDou}</div>\
								</div>\
								<div class="r">\
									<div class="itm how how_${finished}">去完成</div>\
									<div class="itm state state_${finished}"></div>\
								</div>\
							</li>';
		var xsList = '';
		$.each(data, function(k, v) {
			var obj = {
				taskId: (xsTASK.viewMapper[v.taskId] && xsTASK.viewMapper[v.taskId].vId == 6 && !xsTASK.isDaren) ? v.taskId + '_ndr' : v.taskId,
				taskName: v.taskName,
				awardWenDou: v.awardWenDou,
				finished: (xsTASK.viewMapper[v.taskId] == 'update')?'update' : (v.finished ? 'yes' : 'no'),
				hide: !xsTASK.viewMapper[v.taskId] ? 'hide' : '',
			};
			xsList += wentaUtil.template(liTemplate, obj);
		});
		return '<ul class="xsList">'+ xsList +'</ul>';
	},
	renderDailyTask: function(data){
		var liTemplate = '<li class="clearfix xinshou_${finished} task_${taskId} ${taskProgress} ${hide}" taskId="${taskId}" ontouchstart="return true">\
								<div class="l">\
									<div class="itm icon"></div>\
									<div class="itm name">${taskName}</div>\
									<div class="itm wendou">+${awardWenDou}</div>\
								</div>\
								<div class="r">\
									<div class="no hide">\
										<div class="itm how">去完成</div>\
										<div class="itm state"></div>\
									</div>\
									<div class="ing hide">\
										<div class="itm how">进行中</div>\
										<div class="itm data"><div class="itm num">${currentNum}/${goalNum}</div><div class="itm state"></div></div>\
									</div>\
									<div class="yes hide">\
										<div class="itm state state_yes"></div>\
									</div>\
								</div>\
							</li>';
		data.sort(function(a,b){
			return xsTASK.DailyMapper[a.id].rank > xsTASK.DailyMapper[b.id].rank ? 1:-1;
		});

		var xsList = '';
		$.each(data, function(k, v) {
			var obj = {
				taskId: v.id,
				taskName: v.title,
				taskProgress: v.goalNum > 1 ? 'taskProgress':'',
				awardWenDou: v.awardWendou,
				currentNum: v.currentNum,
				goalNum: v.goalNum,
				finished: v.state == 0 ? 'no' : (v.state == 1 ? 'ing' : ((v.state == 2 || v.state == 3) ? 'yes' : '')),
				hide: xsTASK.DailyMapper[v.id].latest ? '' : 'hide'
			};
			xsList += wentaUtil.template(liTemplate, obj);
		});
		return '<ul class="xsList">'+ xsList +'</ul>';
	},
	eventBind: function() {
		$('body').on('click', '.growTask li', function() {
			var that = $(this);
			var taskId = that.attr('taskId');
			var taskMapper = xsTASK.viewMapper[taskId];

			var vName = SwitchOption.SwitchTarget[taskMapper.vId];
			var param = taskMapper.param ? taskMapper.param : {};

			//我要回答页的跳转类名，从上期（十二期，版本号16）增加粉丝求助后开始就变成MainContrainerViewController，十二期之前的版本不变
			if (taskMapper.vId == 2 && (MobileAgent.getPlatform() == 'ios' && WENTA_VERSION >= 16)) {
				vName = {name : "MainContainerViewController",type : 1};
			};
			//16版本开始，达人不区分是否是达人。
			if (taskMapper.vId == 7 && (MobileAgent.getPlatform() == 'ios' && WENTA_VERSION >= 16)) {
				vName = {name : "MasterRoadViewController",type : 0};
			};

			if (that.hasClass('xinshou_no')) {
				navigator.switcher.switchView(vName, param, function(data) {
					// alert(data);
				}, function(message) {
					alert(message); // 输出失败消息。
				});
			};
			if (that.hasClass('xinshou_update')) {
				navigator.version.checkUpdate(function(data) {
				}, function(message) {
				});
			};
		});

		$('body').on('click', '.dailyTask li', function() {
			var that = $(this);
			var taskId = that.attr('taskId');
			
			if (that.hasClass('xinshou_no')) {
				$.when(
					$.post('http://www.7wenta.com/mobile/acceptDailyTask.json',{taskId : taskId},function(data){
						if (data.resultCode.code == 0) {
							that.removeClass('xinshou_no');
							that.addClass('xinshou_ing');
							/*navigator.alert.toast('领取任务成功',0,function(data) {
							}, function(message) {
							});*/
							switchView();
						};
					})
				).fail(function(){
					navigator.alert.toast('请检查网络连接',0,function(data) {
					}, function(message) {
					});
				});
			}else if (that.hasClass('xinshou_ing')){
				switchView();
			}else if (that.hasClass('xinshou_yes')){
				return false;
			}
			
			function switchView(){
				if (xsTASK.DailyMapper[taskId].dcId) {
		        	navigator.commonAgent.onEvent(CommonAgentOption.DataTransferPushTarget[xsTASK.DailyMapper[taskId].dcId], {
					}, function(data) {
			            // alert(data);
			        }, function(message) {
			            alert(message); // 输出失败消息。
			        });
		        }

		        if (xsTASK.DailyMapper[taskId].vId != null) {
		        	navigator.switcher.switchView(SwitchOption.SwitchTarget[xsTASK.DailyMapper[taskId].vId], {}, function(data) {
		            }, function(message) {
		                alert(message); // 输出失败消息。
		            });
		        }else{
		        	if (taskId == 13){ //每日签到
		        		$.when(
							$.post('http://www.7wenta.com/mobile/signin.json',{},function(data){
								if (data.result.resultCode.code == 0) {
									that.removeClass('xinshou_no xinshou_ing');
									that.addClass('xinshou_yes');
									navigator.alert.toast('送你3问豆，记得明天还要回来哦！',0,function(data) {
									}, function(message) {
									});
								};
							})
						).fail(function(){
							navigator.alert.toast('请检查网络连接',0,function(data) {
							}, function(message) {
							});
						});
		        	}
		        }
			}
		});
	}
};

document.addEventListener("deviceready", function(){
	xsTASK.init();
}, false);

document.addEventListener('resume',function(){
	xsTASK.getDaren();
});