var platform = MobileAgent.getPlatform();
var version = MobileAgent.getVersion();
var isAndroid2 = MobileAgent.getPlatform() == 'android' && navigator.userAgent.split('_')[1].split('.')[0] == 2;
var isAndroid4 = MobileAgent.getPlatform() == 'android' && navigator.userAgent.split('_')[1].split('.')[0] == 4;
var page = {
	data : {
		pageStack : [],
		books : null,
		booksMapper : null,
		ids : {
			courseId : 2,
			eduId : window.localStorage.getItem('zsd_eduId'),
			versionId : window.localStorage.getItem('zsd_versionId'),
			gradeId : window.localStorage.getItem('zsd_gradeId')
		}
	},
	util : {
		getFirstAttr : function(obj){
			var o = null;
			$.each(obj,function(k,v){
				o = v;
				return false;
			});
			return o;
		},
		setHtml : function(elemStr,htmlStr){
			$(elemStr).html(htmlStr);
			new IScroll(elemStr + ' .scrollWrp', {
				scrollbars: true,
				mouseWheel: true,
				interactiveScrollbars: true,
				shrinkScrollbars: 'scale',
				scrollbars: 'custom',
				bounce:false,
				// fadeScrollbars: true,//这个会导致android 2.3无法滚动
				click: true
			});
		},
		setIscroller : function(elemStr){
			new IScroll(elemStr + ' .scrollWrp', {
				scrollbars: true,
				mouseWheel: true,
				interactiveScrollbars: true,
				shrinkScrollbars: 'scale',
				scrollbars: 'custom',
				bounce:false,
				// fadeScrollbars: true,//这个会导致android 2.3无法滚动
				click: true
			});
		}
	},
	init : function(){
		/*pushPageStack({name:'index',elem:$('.main'),cb:function(){
			page.switchToSearchPage();
		}});*/
	    page.renderCnt();
		page.eventBind();
		// page.setPageEnd();
	},
	setPageEnd : function(){
		navigator.dataTransfer.push(DataTransferOption.DataTransferPushTarget[1], {
			isPageEnd : false
		}, function(data) {
	        // alert(data);
	    }, function(message) {
	        alert(message); // 输出失败消息。
	    });
	},
	renderCnt : function(){
		page.renderFrame();
		page.setTips();
		page.getBooks();
	},
	renderFrame : function(){
		var str = '<div class="main">\
		                <div class="fixTop">\
		                    <div class="fixTopWrp">\
		                        <div class="overlay"></div>\
		                        <div class="NavBar">\
		                            <div class="NavBarTxt">数学知识全解</div>\
		                        </div>\
		                        <div class="searchBtn" ontouchstart="return!0">搜索</div>\
		                        <div class="chooseBoxWrp">\
		                            <div class="chooseBox">\
		                                <div class="chooseBtn">\
		                                    <div class="txt">选择教材版本</div>\
		                                    <div class="icn"></div>\
		                                </div>\
		                                <div class="chooseListWrp">\
		                                    <div class="chooseList clearfix">\
		                                        <div class="flvl lvl l"></div>\
		                                        <div class="slvl lvl l"></div>\
		                                        <div class="tlvl lvl l"></div>\
		                                    </div>\
		                                </div>\
		                            </div>\
		                        </div>\
		                        <div class="zsdTips">\
		                            <div class="tip0"></div>\
		                            <div class="tip1"></div>\
		                        </div>\
		                    </div>\
		                </div>\
		                <div class="catListWrp"></div>\
		            </div>';
		$('.innerBody').html(str);
	},
	setTips : function(){
		if (!window.localStorage.getItem('zsd_tip')) {
			$('.fixTop').addClass('tip');
			window.localStorage.setItem('zsd_tip',1);
		};
	},
	removeTips : function(){
		$('.fixTop').removeClass('tip');
	},
	getBooks : function(){
		$.get('http://www.7wenta.com/mobile/zsd/books.json',function(data){
			if (data.result.resultCode.code == 0) {
				page.data.books = data.result.value.edus;
				page.data.booksMapper = page.getBooksMapper();
				if (!page.data.ids.eduId) {
					page.renderChooseList();
				}else{
					$('.chooseList').addClass('on');
					page.renderChooseList(page.data.ids.eduId,page.data.ids.versionId,page.data.ids.gradeId);
					page.renderCatList(page.data.ids.courseId,page.data.ids.versionId,page.data.ids.gradeId);
				}			
			};
		});
	},
	getBooksMapper : function(){
		var _edus = {};
		$.each(page.data.books,function(k,v){
			var _editions = {};
			$.each(v.editions,function(k,v){
				var _grades = {};
				$.each(v.grades,function(k,v){
					_grades[v.id] = v;
				});
				_editions[v.id] = {
					id : v.id,
					name : v.name,
					grades : _grades
				};
			});
			_edus[v.id] = {
				id : v.id,
				name : v.name,
				editions : _editions
			};
		});
		return _edus;
	},
	getChooseList : function(eduId,versionId){
		var arrObj = {};
		if (eduId != undefined) {
			for (var i = 0; i < page.data.books.length; i++) {
				if (page.data.books[i].id == eduId) {
					arrObj.slvl = page.data.books[i].editions;
					if (versionId != undefined) {
						for (var j = 0; j < arrObj.slvl.length; j++) {
							if (arrObj.slvl[j].id == versionId) {
								arrObj.tlvl = arrObj.slvl[j].grades;
								break;
							};
						};
					}else{
						arrObj.tlvl = arrObj.slvl[0].grades;
					}
					break;
				};
			};
		}else{
			arrObj.slvl = page.data.books[0].editions;
			arrObj.tlvl = arrObj.slvl[0].grades;
		}
		return arrObj;
	},
	renderChooseList : function(eduId,versionId,gradeId){
		var arrObj = page.getChooseList(eduId,versionId);
		if (eduId == undefined) {
			page.util.setHtml('.chooseListWrp .flvl',renderList(page.data.books,null,1));
			page.util.setHtml('.chooseListWrp .slvl',renderList(arrObj.slvl,null,2));
			page.util.setHtml('.chooseListWrp .tlvl',renderList(arrObj.tlvl,null,3));
		}else{
			if (versionId == undefined) {
				page.util.setHtml('.chooseListWrp .slvl',renderList(arrObj.slvl,versionId,2));
				page.util.setHtml('.chooseListWrp .tlvl',renderList(arrObj.tlvl,null,3));
			}else{
				if (gradeId == undefined) {
					page.util.setHtml('.chooseListWrp .tlvl',renderList(arrObj.tlvl,null,3));
				}else{
					page.util.setHtml('.chooseListWrp .flvl',renderList(page.data.books,eduId,1));
					page.util.setHtml('.chooseListWrp .slvl',renderList(arrObj.slvl,versionId,2));
					page.util.setHtml('.chooseListWrp .tlvl',renderList(arrObj.tlvl,gradeId,3));
			        $('.chooseBtn .txt').html($('.chooseListWrp').find('.slvl .itm.on').text() + $('.chooseListWrp').find('.tlvl .itm.on').text());
				}
			}
		}
		function renderList(arr,id,type){
        	var str = '';
        	for (var i = 0; i < arr.length; i++) {
        		var isOn = '';
        		if (!(type == 3 && id == null)) {
        			if (id == null) {
	        			if (i == 0) {
	        				isOn = 'on';
	        				id = arr[i].id;
	        			};
	        		}else{
	        			if (arr[i].id == id) {
	        				isOn = 'on';
	        			};
	        		}
        		};

        		if (isOn == 'on') {
        			if (type == 1) {
        				page.data.ids.eduId = id;
        			}else if (type == 2) {
        				page.data.ids.versionId = id;
        			};
        		};
        		str += '<div class="itm '+ isOn +'" id="'+ arr[i].id +'">'+ arr[i].name +'</div>';
        	};
        	return '<div class="scrollWrp"><div id="scroller">'+ str +'</div></div>';
        }
        /*var flvl = false;
        var slvl = false;
        var tlvl = false;
		if (eduId == undefined) {
			flvl = slvl = tlvl = true;
			$('.chooseListWrp .flvl').html(renderList(page.data.booksMapper,null,1));
	        $('.chooseListWrp .slvl').html(renderList(page.util.getFirstAttr(page.data.booksMapper).editions,null,2));
	        $('.chooseListWrp .tlvl').html(renderList(page.util.getFirstAttr(page.util.getFirstAttr(page.data.booksMapper).editions).grades,null,3));
		}else{
			if (versionId == undefined) {
				slvl = tlvl = true;
		        $('.chooseListWrp .slvl').html(renderList(page.data.booksMapper[eduId].editions,null,2));
		        $('.chooseListWrp .tlvl').html(renderList(page.util.getFirstAttr(page.data.booksMapper[eduId]).grades,null,3));
			}else{
				if (gradeId == undefined) {
					tlvl = true;
			        $('.chooseListWrp .tlvl').html(renderList(page.data.booksMapper[eduId].editions[versionId].grades,null,3));
				}else{
					flvl = slvl = tlvl = true;
					$('.chooseListWrp .flvl').html(renderList(page.data.booksMapper,eduId,1));
			        $('.chooseListWrp .slvl').html(renderList(page.data.booksMapper[eduId].editions,versionId,2));
			        $('.chooseListWrp .tlvl').html(renderList(page.data.booksMapper[eduId].editions[versionId].grades,gradeId,3));
			        $('.chooseBtn .txt').html($('.chooseListWrp').find('.slvl .itm.on').text() + $('.chooseListWrp').find('.tlvl .itm.on').text());
				}
			}
		}

		function renderList(obj,id,type){
        	var str = '';

        	var i = 0;
        	$.each(obj,function(k,v){
        		var isOn = '';
        		if (!(type == 3 && id == null)) {
        			if (id == null) {
	        			if (i == 0) {
	        				isOn = 'on';
	        				id = v.id;
	        			};
	        		}else{
	        			if (v.id == id) {
	        				isOn = 'on';
	        			};
	        		}
        		};

        		if (isOn == 'on') {
        			if (type == 1) {
        				page.data.ids.eduId = id;
        			}else if (type == 2) {
        				page.data.ids.versionId = id;
        			};
        		};
        		str += '<div class="itm '+ isOn +'" id="'+ v.id +'">'+ v.name +'</div>';
        		i++;
        	});

        	return '<div id="scroller">'+ str +'</div>';
        }*/
	},
	renderCatList : function(courseId,versionId,gradeId){
		$('.catListWrp').html('<div class="loadingWrp">\
								<div class="loading_icon"></div>\
								<div class="loading_txt">正在加载...</div>\
							</div>');
		$.when(
			$.get('http://www.7wenta.com/mobile/zsd/chapter.json',{
				courseId : courseId,
				versionId : versionId,
				gradeId : gradeId
			},function(data){
				if (data.result.resultCode.code == 0) {					
					var chapters = data.result.value.chapters;
					var chapterStr = '';
					if (chapters.length > 0) {
						$.each(chapters,function(k,v){
							var sectionStr = '';
							if (v.hasSection) {
								$.each(v.sections,function(k,v){
									sectionStr += '<div class="itm clearfix" id="'+ v.sId +'">\
				                                        <div class="icn l"></div>\
				                                        <div class="txt toh l">\
				                                            <span>'+ v.sName +'</span> \
				                                        </div>\
				                                    </div>';
								});
							};
							chapterStr += '<div class="catItm on" id="'+ v.sId +'">\
						                            <div class="flvl clearfix">\
						                                <div class="icn l"></div>\
						                                <div class="txt toh l">\
						                                    <span>'+ v.sName +'</span>\
						                                </div>\
						                                <div class="btn r"></div>\
						                            </div>\
						                            <div class="slvl">\
						                                <div class="sList">'+ sectionStr +'</div>\
						                            </div>\
						                        </div>';
						});
						chapterStr = ' <div class="catList">'+ chapterStr +'</div>';
					}else{
						chapterStr = '<div class="noCnt">暂时没有相关内容哦~</div>';
					}
					
					$('.catListWrp').html(chapterStr);
					$('.catListWrp .catItm .flvl').click(function(){
						var that = $(this);
						that.closest('.catItm').toggleClass('on');
					});
					$('.catListWrp .catItm .slvl .itm').click(function(){
						var that = $(this);
						var href = 'http://www.7wenta.com/mbweb/res/www/page/zsd/sec.htm?'+ (wentaUtil.isDebug()?'isDebug=true&':'') +'versionId='+ page.data.ids.versionId +'&gradeId='+ page.data.ids.gradeId +'&chapterId='+ that.closest('.catItm').attr('id') +'&sectionId='+ that.attr('id') +'&sectionName='+ encodeURIComponent(that.find('.txt span').text());
						if (wentaUtil.isDebug()) {
							window.location.href = href;
						}else{
							navigator.switcher.switchView(SwitchOption.SwitchTarget[22], {
								key_web_title : '知识点详情', 
								key_web_url : href,
								key_keep_swipe : 0
							}, function(data) {
							}, function(message) {
								alert(message); // 输出失败消息。
							});
						}
					});
				};
			})
		).fail(function(){
			$('.catListWrp').html('<div class="noCnt">网络请求失败，请检查网络是否连接</div>');
		});
	},
	switchToSearchPage : function(){
		var param = {
			"key_search_content": '',
			"key_search_type": 2 //0表示普通搜索，1表示作文搜索
		};
		var switchId = 15;
		if ((platform == 'android' && version >= 34) || (platform == 'ios' && version >= 25)) {
			switchId = 18;
		};
		navigator.switcher.switchView(SwitchOption.SwitchTarget[switchId], param, function(data) {
        }, function(message) {
            alert(message); // 输出失败消息。
        });
	},
	eventBind : function(){		
		$('.searchBtn').click(function(){
			page.switchToSearchPage();
			page.removeTips();
			return false;
		});
		$('.NavBar').click(function(){
			return false;
		});
		$('.chooseBtn').click(function(){
			if ($('.fixTop').hasClass('on')) {
				$('.fixTop').removeClass('on')
			}else{
				$('.fixTop').addClass('on')
				page.util.setIscroller('.chooseListWrp .flvl');
				page.util.setIscroller('.chooseListWrp .slvl');
				page.util.setIscroller('.chooseListWrp .tlvl');
			}
			page.removeTips();
			return false;
		});
		$('.fixTop .overlay').click(function(){
			$('.fixTop').removeClass('on');
			page.removeTips();
			return false;
		});
		$('body').on('click','.chooseList .itm',function(){
			var that = $(this);
			var parent = that.closest('.lvl');

			parent.find('.itm').removeClass('on');
			that.addClass('on');

			if (parent.hasClass('flvl')) {
				page.data.ids.eduId = that.attr('id');
				page.renderChooseList(page.data.ids.eduId);
			}else if (parent.hasClass('slvl')) {
				page.data.ids.versionId = that.attr('id');
				page.renderChooseList(page.data.ids.eduId,page.data.ids.versionId);
				$('.chooseList').addClass('on');
			}else if (parent.hasClass('tlvl')) {
				page.data.ids.gradeId = that.attr('id');
				page.renderCatList(page.data.ids.courseId,page.data.ids.versionId,page.data.ids.gradeId);
				$('.fixTop').removeClass('on');
				$('.chooseBtn .txt').html($('.chooseListWrp').find('.slvl .itm.on').text() + $('.chooseListWrp').find('.tlvl .itm.on').text());

				window.localStorage.setItem('zsd_eduId',page.data.ids.eduId);
				window.localStorage.setItem('zsd_versionId',page.data.ids.versionId);
				window.localStorage.setItem('zsd_gradeId',page.data.ids.gradeId);
			}
			return false;
		});
	}
}
document.addEventListener("deviceready", function(){
	page.init();
}, false);

/*document.addEventListener("resume", function(){
	$('.searchBarWrp').removeClass('lock');
}, false);*/

function pageChange(){
	/*if (page.data.pageStack[0].name == 'index') {
		page.data.pageStack[0].elem.show();
	};*/
	navigator.dataTransfer.push(DataTransferOption.DataTransferPushTarget[1], {
		isPageEnd : (page.data.pageStack[0].name == 'index')?true:false
	}, function(data) {
        // alert(data);
    }, function(message) {
        alert(message); // 输出失败消息。
    });
}
function pushPageStack(o){
	page.data.pageStack.unshift(o);
	pageChange();
}
function popPageStack(){
	if (page.data.pageStack[0].cb) {
		page.data.pageStack[0].cb();
	}else{
		page.data.pageStack[0].elem.remove();
	}
	page.data.pageStack.shift();
	pageChange();
}
function gotoPageStack(name){
	var count = 0;
	for (var i = 0; i < page.data.pageStack.length; i++) {
		if (page.data.pageStack[i].name != name) {
			page.data.pageStack[i].elem.remove();
			count ++;
		}else{
			break;
		}
	};
	page.data.pageStack = page.data.pageStack.slice(count);
	pageChange();
}

/* 
*  客户端左上角返回按钮的js回调
*/ 
function backButtonCallback() {
	popPageStack();
}