;(function($){
	$.btmMenu = function(opts){
		var self = this;
		var _defaults = {
			parent : $("body"),
			sureClose : false,
			aniTime : 200,
			itmArr : [{
				name : '',
				cb : function($box,elem){}
			}]
		};
		self.settings = $.extend({},_defaults,opts);

		var isAndroid4 = MobileAgent.getPlatform() == 'android' && navigator.userAgent.split('_')[1].split('.')[0] == 4;

		if ($('.btmMenuWrp').length > 0) {
			return false;
		};

		var boxTemplate = '<div class="btmMenuWrp">\
								<div class="btmMenuOverlay"></div>\
								<div class="btmMenu">\
									<div class="itm_sureWrp"></div>\
									<div class="itm itm_cancel" ontouchstart="return true">取消</div>\
								</div>\
							</div>';
		var $box = $(boxTemplate);
		var $Box = $box.find(".btmMenu");
		var $overlay = $box.find(".btmMenuOverlay");

		$box.bind('showPanel',function(){
			$box.appendTo(self.settings.parent);
			window.pushPageStack && pushPageStack({name:'btmMenu',elem:$box});

			if (isAndroid4) {
				$Box.css({
					"-webkit-transform" : "translateY("+  ($Box.outerHeight()) +"px)"
				});
				setTimeout(function(){
					$overlay.fadeIn(self.settings.aniTime);
					$Box.css({
						"-webkit-transition" : "all "+ self.settings.aniTime/1000 +"s linear 0",
						"-webkit-transform" : "translateY(0px)"
					});
				},0);
			}else{
				$Box.css({
					"bottom" : "-"+  ($Box.outerHeight()) +"px"
				});
				setTimeout(function(){
					$overlay.fadeIn(self.settings.aniTime);
					$Box.animate({
						"bottom" : "0px"
					},self.settings.aniTime);
				},0);
			};
		})
		$box.on('hidePanel',function(e,param){
			var param = param || {};
			$overlay.fadeOut(self.settings.aniTime);

			if (!param.noAnimate) {
				if (isAndroid4) {
					$Box.css({
						"-webkit-transform" : "translateY("+  ($Box.outerHeight()) +"px)"
					});
					setTimeout(function(){
						remove();
					},self.settings.aniTime);
				}else{
					$Box.animate({
						"bottom" : "-"+  ($Box.outerHeight()) +"px"
					},self.settings.aniTime,function(){
						remove();
					});
				};
			}else{
				remove();
			}			
			
			function remove(){
				if (window.popPageStack) {
					popPageStack();
				}else{
					$box.remove();
				}
				param.cb && param.cb();
			}
		})
		
		$overlay.css({height : $(document).height()});

		$box.find('.btmMenuOverlay,.itm_cancel').click(function(){
			$box.trigger('hidePanel');
		});

		for (var i = 0; i < self.settings.itmArr.length; i++) {
			var itmStr = '<div class="itm itm_sure" ontouchstart="return true">'+ self.settings.itmArr[i].name +'</div>';
			var $itm = $(itmStr);
			(function(i){
				$itm.click(function(){
					self.settings.itmArr[i].cb && self.settings.itmArr[i].cb($box,$itm);
					if (self.settings.sureClose) {
						$box.trigger('hidePanel');
					};
				});
			})(i);
			$itm.appendTo($box.find('.itm_sureWrp'));
		};

		$box.trigger('showPanel');

		function getPlatform() {
			var userAgent = (navigator.userAgent).toLowerCase(),
				agentArr = userAgent.split("_");
			var platform = userAgent.substr(0, 7),
				platform1 = userAgent.substr(0, 3);
			if (platform == "android") {
				return "android";
			}
			if (platform1 == "ios") {
				return "ios";
			}
			return "ios";
		}
	};
})(jQuery);