var CommonModule = {
	widget : {
		initDailyTask : function(opts){
			var _defaults = {
				elem : $('.dailyTaskBoxWrp'),
				txt: '',
				suc : function(elem){},
				fail : function(elem){}
			};
			var settings = $.extend({},_defaults,opts);
			var actionUrl = 'http://www.7wenta.com/mobile/unFinishDailyTasks.json?os='+ MobileAgent.getPlatform() +'&vercode=' + MobileAgent.getVersion();
			$.when(
				$.get(actionUrl, function(data) {
					if (data.result.resultCode.code == 0) {
						if (data.result.value.dailyTask.length > 0) {
							var template = '<div class="dailyTaskBox">\
												<div class="txt">${txt}</div>\
												<div class="xsBlock dailyTask">${dailyTask}</div>\
											</div>';
							var obj = {
								txt : settings.txt,
								dailyTask : renderDailyTask(data.result.value.dailyTask)
							};
							var $box = $(wentaUtil.template(template, obj));
							settings.elem.html($box);
							eventBind($box);
							settings.suc && settings.suc();
						}else{
							settings.fail && settings.fail();
						};
					}else{
						settings.fail && settings.fail();
					}
				})
			).fail(function(){
				settings.fail && settings.fail();
			});

			function renderDailyTask(data){
				var liTemplate = '<li class="clearfix xinshou_${finished} task_${taskId} ${taskProgress}" taskId="${taskId}" ontouchstart="return true">\
										<div class="l">\
											<div class="itm icon" style="background-image:url(${taskIcon});"></div>\
											<div class="itm name">${taskName}</div>\
											<div class="itm wendou">+${awardWenDou}</div>\
										</div>\
										<div class="r">\
											<div class="no hide">\
												<div class="itm how">去完成</div>\
												<div class="itm state"></div>\
											</div>\
											<div class="ing hide">\
												<div class="itm how">进行中</div>\
												<div class="itm data"><div class="itm num">${currentNum}/${goalNum}</div><div class="itm state"></div></div>\
											</div>\
											<div class="yes hide">\
												<div class="itm state state_yes"></div>\
											</div>\
										</div>\
									</li>';
				var xsList = '';
				$.each(data, function(k, v) {
					var obj = {
						taskId: v.id,
						taskName: v.title,
						taskIcon: v.imgUrl,
						taskProgress: v.goalNum > 1 ? 'taskProgress':'',
						awardWenDou: v.awardWendou,
						currentNum : v.currentNum,
						goalNum : v.goalNum,
						finished: v.state == 0 ? 'no' : (v.state == 1 ? 'ing' : ((v.state == 2 || v.state == 3) ? 'yes' : ''))
					};
					xsList += wentaUtil.template(liTemplate, obj);
				});
				return '<ul class="xsList">'+ xsList +'</ul>';
			}
			function eventBind($box){
				$box.find('.dailyTask li').click(function() {
					var that = $(this);
					var taskId = that.attr('taskId');
					
					if (that.hasClass('xinshou_no')) {
						return false;
					}else if (that.hasClass('xinshou_ing')){
						switchView();
					}else if (that.hasClass('xinshou_yes')){
						return false;
					}
					
					function switchView(){
						var mapper = {
							'8' : {vId : 2, dcId : 'DAILY_TASK_ADOPT'},
							'9' : {vId : 5, dcId : 'DAILY_TASK_INVITE'},
							'10' : {vId : 2, dcId : 'DAILY_TASK_ANSWER'},
							'11' : {vId : 21, dcId : 'DAILY_TASK_ECHAT'},
							'12' : {vId : 20, dcId : 'DAILY_TASK_SHARE_WENTA'},
							'13' : {vId : null, dcId : 'DAILY_TASK_SIGN_IN'} //每日签到不显示
						};

						if (mapper[taskId].dcId) {
				        	navigator.commonAgent.onEvent(CommonAgentOption.DataTransferPushTarget[mapper[taskId].dcId], {
							}, function(data) {
					            // alert(data);
					        }, function(message) {
					            alert(message); // 输出失败消息。
					        });
				        }

				        if (mapper[taskId].vId != null) {
				        	navigator.switcher.switchView(SwitchOption.SwitchTarget[mapper[taskId].vId], {}, function(data) {
				            }, function(message) {
				                alert(message); // 输出失败消息。
				            });
				        }
					}
				});
			}
		},
		initShareBox : function(opts){
			$.wtBox({
				wholeCnt:'<div class="shareBox">\
							<div class="mainWrp">\
								<div class="shareTxt">\
					                <p>分享给好友</p>\
					            </div>\
					            <div class="sp"></div>\
					            <div class="shareWrp">\
					            	<a href="javascript:;" class="sItem sqq" data-sharecode="qq">QQ</a>\
					            	<a href="javascript:;" class="sItem sqz" data-sharecode="qzone">QQ空间</a>\
					                <a href="javascript:;" class="sItem swx" data-sharecode="weixin">微信</a>\
					            </div>\
					            <div class="shareWrp">\
					                <a href="javascript:;" class="sItem spyq" data-sharecode="friend">朋友圈</a>\
					                <a href="javascript:;" class="sItem sxlwb" data-sharecode="weibo">新浪微博</a>\
					                <a href="javascript:;" class="sItemNull"></a>\
					            </div>\
							</div>\
						</div>',
				backClose : true,
				after : function(elem){
					elem.find('.sItem').click(function(){
						var index = $(this).data("sharecode");
						var comment = opts.comment;
				    	var shareContent = {
				            shareKey:"wenta",// 必须
				            weixin:comment,
				            friend:comment,
				            qq:comment,
				            weibo:opts.weiboComment ? opts.weiboComment : comment,
				            tencent:comment,
				            qzone:comment,
				            targetUrl:opts.url,
				            imgUrl:opts.img,
				            iconUrl:opts.defaultImg,  // 微信、朋友圈
				            otherUrl:opts.url // 如果存在otherUrl字段，则会把该字段拼接到新浪微博和腾讯微博分享文案内容后面。此外，qq分享必须存在该字段
				        };
						BtCommunication.simpleShareTo(index,shareContent,function(cmd,shareCode){
			                opts.suc && opts.suc(shareCode);
			                if (MobileAgent.getPlatform() == 'android') {
			                	navigator.alert.toast('分享成功',0,function(data) {
								}, function(message) {
								});
			                };
			            },function(cmd,shareCode){
			            	navigator.alert.toast('分享失败',0,function(data) {
							}, function(message) {
							});
			            });
					});
					$(window).scrollTop($(window).scrollTop()+0);
				}
			});
		}
	}
}