var isAndroid4 = MobileAgent.getPlatform() == 'android' && navigator.userAgent.split('_')[1].split('.')[0] == 4;
var page = {
	data : {
		pageStack : [],
		hasLogin : false,
		bannerImg : '',
		wbdMapper : {
			0 : {name : '问豆', tag : 'wd'}, 
			1 : {name : '问贝', tag : 'wb'} 
		},
		daojuMapper : {
			1 : {name : '永久黄金提问卡'}, 
			2 : {name : '30天黄金提问卡A套餐'}, 
			3 : {name : '30天黄金提问卡B套餐'}, 
			4 : {name : '30天黄金提问卡C套餐'}, 
			5 : {name : '永久黄金提问卡(MM商城版)'}, 
			15 : {name : '7天黄金提问卡'}, 
			13 : {name : '申优卡'}, 
			16 : {name : '大熊猫气泡'}, 
			17 : {name : '汪星人气泡'}, 
			18 : {name : '喵星人气泡'}, 
			19 : {name : '小浣熊气泡'}
		}
	},
	util : {
		subStrByLen : function(str,len){
			if (str) {
				if (str.length <= len) {
					return str;
				}else{
					return str.substr(0,len) + '...';
				}
			}else{
				return '';
			}
		}
	},
	init : function(){
		pushPageStack({name:'index',elem:$('.shopBox')});
		page.setData();
		page.getCntData();
		page.eventBind();
	},
	setData : function(){
		navigator.dataTransfer.push(DataTransferOption.DataTransferPushTarget[2], {
			show : true,
			content : ['问他商城']
		}, function(data) {
		}, function(message) {
	        alert(message); // 输出失败消息。
	    });
	    navigator.dataTransfer.pull(DataTransferOption.DataTransferPullTarget[0], {}, function(data) {
	        page.data.hasLogin = data;
	    }, function(message) {
	        alert(message); // 输出失败消息。
	    });
	    navigator.dataTransfer.pull(DataTransferOption.DataTransferPullTarget[1], {}, function(data) {
            page.data.bannerImg = data[0];
        }, function(message) {
            alert(message); // 输出失败消息。
        });

        navigator.dataTransfer.pull(DataTransferOption.DataTransferPullTarget[2], {}, function(data) {
            page.data.hasPassVerify = data;
        }, function(message) {
            alert(message); // 输出失败消息。
        });
	},
	getCntData : function(){
		cordovaDebug.getJSON('http://www.7wenta.com/mobile/shopItems.json', function(data){
			if (data.result.resultCode.code == 0) {
				var shopItems = data.result.value;
				setTimeout(function(){
					$('.loadingWrp').hide();
					page.renderCnt(shopItems);
				},0);
			};
		},function(){
			$('.loadingWrp').html('网络异常，请查看网络是否连接');
			$('.loadingWrp').click(function(){
				window.location.reload();
			});
		});
	},
	renderCnt : function(data){
		var template = '<div class="shopBox">${banner}\
							<div class="dataLink clearfix pr">\
								<div class="dLink dLink_wd clearfix">\
									<div class="dLink_l l clearfix">\
										<div class="dLinkWrp l clearfix">\
											<div class="dLink_tbl clearfix">\
												<div class="itm l caina">\
													<div class="tag">7天采纳</div>\
													<div class="num">${caina}</div>\
												</div>\
												<div class="itm l wendou">\
													<div class="tag">问豆</div>\
													<div class="num">${wendou}</div>\
												</div>\
											</div>\
										</div>\
									</div>\
									<div class="dLink_r r clearfix">\
										<div class="dLinkWrp r clearfix">\
											<div class="link link_yq r">邀请送豆</div>\
											<div class="link link_dt link r">答题赚豆</div>\
										</div>\
									</div>\
								</div>\
								<div class="dLink dLink_nlog clearfix">\
									<div class="dLink_nlogTxt l">登录后就可以赚问豆<em>换奖品</em>啦！</div>\
									<div class="dLink_nlogBtn r">登录</div>\
								</div>\
							</div>\
							<div class="gdZone">\
								<div class="gdZone_wd">\
									<div class="gdBlock">\
										<div class="gdTag">实体商品</div>\
										<div class="gdList clearfix">${realGood}</div>\
									</div>\
									<div class="gdBlock">\
										<div class="gdTag">道具商品</div>\
										<div class="gdList clearfix">${djGood_wd}</div>\
									</div>\
								</div>\
							</div>\
						</div>';
		var obj = {
			caina : data.weekAdoptCount,
			wendou : data.wenDouCount,
			realGood : page.renderGoods(data.realShopGoods),
			djGood_wd : page.renderGoods(data.wenDouDaojuShopGoods),
			banner : page.data.bannerImg?'<div class="banner"><img data-real="'+ page.data.bannerImg +'"></div>' : ''
		};
		var shopBox = wentaUtil.template(template, obj);
		var $shopBox = $(shopBox);

		$('.innerBody').append($shopBox);

		$shopBox.find(".banner").height($(window).width() * 0.375);
		
		cordovaDebug.getImg($('.banner img').data('real'),function(data){
			$('.banner img').attr('src',data);
		});

		$shopBox.find(".gdImg img").lazyload({
			skip_invisible:false,
			effect:"fadeIn",
			appear:function(){
				var that = $(this);
				cordovaDebug.getImg(that.data('real'),function(data){
					that.attr('src',data);
				});
			}
		});

		if (page.data.hasLogin) {
			$shopBox.find(".dLink_wd").show();
		}else{
			$shopBox.find(".dLink_nlog").show();
		}
	},
	renderGoods : function(arr){
		var str = '';
		var template = '<div class="gdItmWrp">\
							<div class="gdItm ${gdType} gdItm_${goodsId} gdItm_${disabled}" priceType="${priceType}" goodsId="${goodsId}" itemTypeId="${itemTypeId}" imgB="${imgB}" canBuy="${canBuy}" reason="${reason}" caina="${caina}" ontouchstart="return true">\
								<div class="gdImg">\
									${img}\
								</div>\
								<div class="gdName toh">${name}</div>\
								<div class="gdBtm clearfix">\
									<div class="yesBuy">\
										<div class="gdPrice l">${price}</div>${teJia}\
									</div>\
									<div class="noBuy hide">\
										<div class="gdTxt l">下次再来噢~</div>\
										<div class="gdTip r">已换完</div>\
									</div>\
								</div>\
								<div class="gdDetail hide">${detail}</div>\
							</div>\
						</div>';
		for (var i = 0; i < arr.length; i++) {
			var v = arr[i];
			var obj = {
				img : page.data.daojuMapper[v.goodsId] ? ('<img src="'+ httpLk + 'resource/common/style/image/loading_s.png" data-real="http://static.7wenta.com/mobile/wap/shop/djImg/' + v.goodsId + '_s.jpg" />'):('<img src="'+ httpLk + 'resource/common/style/image/loading_s.png" data-real="'+ v.imgUrls[0] + '" />'),
				imgB : page.data.daojuMapper[v.goodsId] ? ('http://static.7wenta.com/mobile/wap/shop/djImg/' + v.goodsId + '_b.jpg'):v.imgUrls[1],
				name : v.name,
				price : v.price,
				gdType : 'gdItm' + v.priceType,
				priceType : v.priceType,
				detail : v.detail,
				itemTypeId : v.itemTypeId,
				goodsId : v.goodsId,
				canBuy : v.canBuy,
				disabled : (page.data.daojuMapper[v.goodsId] || !page.data.hasLogin)?'yes':(v.canBuy?'yes':'no'),
				teJia : v.teJia?'<div class="gdTip r">特价</div>':'',
				reason : v.reason,
				caina : v.adoptNum
			}
			str += wentaUtil.template(template,obj);
		};
		return str;
	},
	afterBuy : function(goodsId,priceType){
		var wdb = page.data.wbdMapper[priceType];
		$('.dLink_'+ wdb.tag +' .dLink_tbl .wendou .num').html($('.dLink_'+ wdb.tag +' .dLink_tbl .wendou .num').html() - $('.gdItm_'+goodsId).find('.gdPrice').html());
	},
	buyRealItem : function(goodsId,dest,elem){
		var param = {
			goodsId : goodsId,
			buyCount : 1,
			dest : dest
		};
		$.when($.post('http://www.7wenta.com/mobile/buyRealItem.json',param,function(data){
			if (data.result.resultCode.code == 0) {
				gotoPageStack('index');
				page.afterBuy(goodsId, $('.gdItm_'+goodsId).attr('priceType'));
				$.wtBox({
					wholeCnt:'<div class="gdBox pr">\
								<div class="gdImg">'+ ('<img src="'+ httpLk + 'resource/common/style/image/loading_b.png" data-real="'+ $('.gdItm_'+goodsId).attr('imgB') + '" />') +'</div>\
								<div class="gdCnt">\
									<div class="sub">\
										<div class="gdInfo wbk">'+ $('.gdItm_'+goodsId).find('.gdName').html() +'的兑换请求已经提交成功，请耐心等待审核，可以随时到我的物品中查看礼品的处理状态哦~</div>\
									</div>\
									<div class="submit">晒礼品</div>\
								</div>\
								<div class="close pa"></div>\
							</div>',
					after : function(elem){
						cordovaDebug.getImg(elem.find('.gdImg img').data('real'),function(data){
							elem.find('.gdImg img').attr('src',data);
						});
						elem.find('.close').click(function(){
							popPageStack();
						});
						elem.find('.submit').click(function(){
							page.initShareBox(goodsId);
						});
					}
				})
			}else{
				navigator.alert.toast(data.result.resultCode.detail,0,function(data) {
				}, function(message) {
				});
			}
		})).always(function(){
			elem.removeClass('lock');
		}).fail(function(){
			navigator.alert.toast('请检查网络连接',0,function(data) {
			}, function(message) {
			});
		});
	},
	buyDaojuItem : function(goodsId,elem){
		var param = {
			goodsId : goodsId,
			buyCount : 1
		};
		$.when($.post('http://www.7wenta.com/mobile/shopping.json',param,function(data){
			if (data.result.resultCode.code == 0) {
				popPageStack();
				page.afterBuy(goodsId, $('.gdItm_'+goodsId).attr('priceType'));
				navigator.alert.toast('兑换成功!请到‘我的物品’中查看和使用道具',0,function(data) {
				}, function(message) {
				});
			}else{
				navigator.alert.toast(data.result.resultCode.detail,0,function(data) {
				}, function(message) {
				});
			}
		})).always(function(){
			elem.removeClass('lock');
		}).fail(function(){
			navigator.alert.toast('请检查网络链接',0,function(data) {
			}, function(message) {
			});
		});
	},
	showNumberBox : function(name,itemTypeId,goodsId){
		gotoPageStack('index');
		var mapper = {
			11 : {
				name : '手机',
				valid : /^\d{5,12}$/
			},
			12 : {
				name : 'QQ',
				valid : /^1\d{10}$|^(\d{4}-|\d{3}-)?(\d{8}|\d{7})$/
			}
		};
		$.wtBox({
			wholeCnt:'<div class="numberBox">\
						<div class="mainWrp">\
							<div class="title">'+ name +'</div>\
							<div class="first">\
								<input class="cS" type="text" placeholder="请输入您要充值的'+ mapper[itemTypeId].name +'号码"/>\
							</div>\
							<div class="second">\
								<input class="cS" type="text" placeholder="请再次输入您要充值的'+ mapper[itemTypeId].name +'号码"/>\
							</div>\
							<div class="sub clearfix">\
								<div class="btn cancel">取消</div>\
								<div class="btn sure">立即兑换</div>\
							</div>\
						</div>\
					</div>',
			after : function(elem){
				elem.find('.first input').focus();
				
				elem.find('.cancel').click(function(){
					popPageStack();
				});
				elem.find('.sure').click(function(){
					var that = $(this);
					if (getNumber()) {
						popPageStack();
						$.wtBox({
							wholeCnt:'<div class="sureBox sureBox_nb">\
										<div class="sbBox main pr">\
											<div class="mainWrp">\
												<div class="title">小问提醒你，请再次确认你填写的<em>'+ mapper[itemTypeId].name +'号码</em>无误，一旦提交兑换，将不能再更改哦！</div>\
												<div class="data">你填写的<em>'+ mapper[itemTypeId].name +'号码</em>为：<em>'+ getNumber() +'</em></div>\
											</div>\
											<div class="xwIcon pa"></div>\
										</div>\
										<div class="sbBox sub clearfix">\
											<div class="btn cancel" ontouchstart="return true">填错了</div>\
											<div class="btn sure" ontouchstart="return true">确认</div>\
										</div>\
									</div>',
							after : function(elem){
								elem.find('.cancel').click(function(){
									popPageStack();
									page.showNumberBox(name,itemTypeId,goodsId);
								});
								elem.find('.sure').click(function(){
									var that = $(this);
									if (!that.hasClass('lock')) {
										that.addClass('lock');
										page.buyRealItem(goodsId,getNumber(),that);
									};
								});
							}
						});
					};
				});

				function getNumber(){
					var value = elem.find('.first input').val();
					var _value = elem.find('.second input').val();
					if (!value) {
						navigator.alert.toast(mapper[itemTypeId].name +'号码不能为空',0,function(data) {
						}, function(message) {
						});
						return false;
					};
					if (!(/^\d+$/g.test(value))) {
						navigator.alert.toast(mapper[itemTypeId].name +'号码必须为数字',0,function(data) {
						}, function(message) {
						});
						return false;
					};
					if (value == _value) {
						return value;
					}else{
						navigator.alert.toast('请输入相同的'+ mapper[itemTypeId].name +'号码',0,function(data) {
						}, function(message) {
						});
						return false;
					}
				}
			}
		})
	},
	showAddress : function(goodsId){
		gotoPageStack('index');
		$('.gdZone').addClass('lock');
		$.when($.get('http://www.7wenta.com/mobile/address.json',{offset:0,limit:10},function(data){
			if (data.result.resultCode.code == 0) {
				var value = data.result.value;
				var defaultAds = '';
				var hasDefault = value.userAddresses.length > 0;
				var fisrtValue = value.userAddresses.length > 0 ? value.userAddresses[0] : {};
				var address = '<div class="addressBox">\
									<div class="defaultAds adsBlock" id="'+ fisrtValue.addressId +'">\
										<div class="chooseAds chooseBlock clearfix">\
											<em class="status"></em><span class="txt">使用默认收件地址</span>\
										</div>\
										<div class="data">\
											<div>收件人：'+ fisrtValue.name +'（'+ fisrtValue.phonNumber +'）</div>\
											<div>地址：'+ fisrtValue.address +'</div>\
											<div>邮编：'+ fisrtValue.postcode +'</div>\
										</div>\
									</div>\
									<div class="otherAds adsBlock">\
										<div class="chooseAds chooseBlock clearfix">\
											<em class="status"></em><span class="txt">使用其他收件地址</span>\
										</div>\
										<div class="otherAdsWrp">\
											<div class="adInfoWrp">\
												<div class="adInfo adInfo_T name">\
													<textarea class="cS" placeholder="收件人姓名"></textarea>\
												</div>\
												<div class="adInfo adInfo_T phonNumber">\
													<textarea class="cS" placeholder="收件人电话" ></textarea>\
												</div>\
												<div class="adInfo adInfo_T postcode">\
													<textarea class="cS" placeholder="邮政编码" ></textarea>\
												</div>\
												<div class="adInfo adInfo_S province" type="province" ontouchstart="return true">\
													<div class="cnt"><span class="name">省份</span><span class="value hide"></span></div>\
												</div>\
												<div class="adInfo adInfo_S city" type="city" ontouchstart="return true">\
													<div class="cnt"><span class="name">市</span><span class="value hide"></span></div>\
												</div>\
												<div class="adInfo adInfo_S area" type="area" ontouchstart="return true">\
													<div class="cnt"><span class="name">区/县</span><span class="value hide"></span></div>\
												</div>\
												<div class="adInfo adInfo_L detailAddress">\
													<textarea class="cS" placeholder="详细地址" maxlength="200"></textarea>\
												</div>\
											</div>\
											<div class="chooseAds chooseDefault clearfix">\
												<div class="chooseDefaultWrp l">\
													<em class="status"></em><span class="txt">设为默认收件地址</span>\
												</div>\
											</div>\
										</div>\
									</div>\
									<div class="submit" ontouchstart="return true">提交</div>\
								</div>';
				var $address = $(address);

				if (hasDefault) {
					$address.find('.defaultAds').addClass('adsBlock_on');
					$address.find('.defaultAds .chooseBlock').addClass('chooseAds_on');
					$address.find('.otherAds').find('textarea').attr('disabled',true);
					$address.find('.otherAds').find('.adInfo_S').attr('disabled',true);
					$address.find('.otherAdsWrp').addClass('hide');
				}else{
					$address.find('.defaultAds').addClass('hide');
					$address.find('.otherAds .chooseBlock').addClass('hide');
					$address.find('.chooseDefault').addClass('chooseAds_on');
					$address.find('.submit').addClass('submit_no');
				};

				Publisher.listen('addressCheckValid',function(){
					var hasInput = false;
					$('.otherAds .adInfo').each(function(){
						var that = $(this);
						if (((that.hasClass('adInfo_T') || that.hasClass('adInfo_L')) && that.find('textarea').val()) || (that.hasClass('adInfo_S') && that.attr('id'))) {
							hasInput = true;
						}else{
							hasInput = false;
							that.addClass('error');
							return false;
						}
					})
					if (hasInput) {
						$address.find('.submit').removeClass('submit_no');
					}else{
						$address.find('.submit').addClass('submit_no');
					}
				});

				$address.find('.adInfo_S').click(function(){
					var that = $(this);
					if (!that.attr('disabled')) {
						if (!that.hasClass('lock')) {
							that.removeClass('error');
							var param = {
								provinceId : $address.find('.province').attr('id'),
								cityId :  $address.find('.city').attr('id')
							};
							if (that.hasClass('area') && !$address.find('.city').attr('id')) {
								navigator.alert.toast('请先选择城市',0,function(data) {
								}, function(message) {
								});
							}else if (that.hasClass('city') && !$address.find('.province').attr('id')) {
								navigator.alert.toast('请先选择省份',0,function(data) {
								}, function(message) {
								});
							}else{
								that.addClass('lock');
								page.showSelectBox(that.attr('type'),param);
							}
						}
					};
				});
				$address.find('.adInfo textarea').click(function(){
					var that = $(this);
					var parent = that.closest('.adInfo');
					parent.removeClass('error');
				});
				$address.find('.adInfo textarea').blur(function(){
					Publisher.fire('addressCheckValid');
				});
				$address.find('.adInfo textarea').keyup(function(){
					Publisher.fire('addressCheckValid');
				});
				$address.find('.adsBlock .chooseBlock').click(function(){
					var that = $(this);
					var parent = that.closest('.adsBlock');
					$address.find('.adsBlock .chooseBlock').removeClass('chooseAds_on');
					that.addClass('chooseAds_on');
					$address.find('.adsBlock').removeClass('adsBlock_on');
					parent.addClass('adsBlock_on');

					if (parent.hasClass('otherAds')) {
						$address.find('.otherAdsWrp').removeClass('hide');
						$address.find('.otherAds').find('textarea').removeAttr('disabled');
						$address.find('.otherAds').find('.adInfo_S').removeAttr('disabled');
						$address.find('.chooseDefault').addClass('chooseAds_on');
						Publisher.fire('addressCheckValid');
					}else{
						$address.find('.otherAdsWrp').addClass('hide');
						$address.find('.otherAds').find('textarea').attr('disabled',true);
						$address.find('.otherAds').find('.adInfo_S').attr('disabled',true);
						$address.find('.submit').removeClass('submit_no');
						$address.find('.chooseDefault').removeClass('chooseAds_on');
					}
				});
				$address.find('.chooseDefaultWrp').click(function(){
					var that = $(this);
					$address.find('.chooseDefault').toggleClass('chooseAds_on');
				});
				$address.find('.submit').click(function(){
					var that = $(this);
					if (!that.hasClass('submit_no')) {
						if ($('.defaultAds .chooseBlock').hasClass('chooseAds_on')) {
							var addressId = $('.defaultAds').attr('id');
							$.wtBox({
								wholeCnt:'<div class="sureBox">\
											<div class="sbBox main pr">\
												<div class="mainWrp">\
													<div class="title">小问提醒你，请再次确认收货信息无误，<br>一旦下单，将不能更改收货信息！</div>\
													<div class="data">'+ $('.defaultAds .data').html() +'</div>\
												</div>\
												<div class="xwIcon pa"></div>\
											</div>\
											<div class="sbBox sub clearfix">\
												<div class="btn cancel" ontouchstart="return true">填错了</div>\
												<div class="btn sure" ontouchstart="return true">确认</div>\
											</div>\
										</div>',
								after : function(elem){
									elem.find('.cancel').click(function(){
										popPageStack();
									});
									elem.find('.sure').click(function(){
										var that = $(this);
										if (!that.hasClass('lock')) {
											that.addClass('lock');
											page.buyRealItem(goodsId,addressId,that);
										};
									});
								}
							});
						}else{
							var param = {
								name: $('.otherAds .name textarea').val(),
								phonNumber: $('.otherAds .phonNumber textarea').val(),
								postcode: $('.otherAds .postcode textarea').val(),
								address: $('.otherAds .detailAddress textarea').val(),
								provinceId: $('.otherAds .province').attr('id'),
								cityId: $('.otherAds .city').attr('id'),
								areaId: $('.otherAds .area').attr('id'),
								defaultAdd: $('.chooseDefault').hasClass('chooseAds_on')?true:false
							}
							$.wtBox({
								wholeCnt:'<div class="sureBox">\
											<div class="sbBox main pr">\
												<div class="mainWrp">\
													<div class="title">小问提醒你，请再次确认收货信息无误，<br>一旦下单，将不能更改收货信息！</div>\
													<div class="data">\
														<div>收件人：'+ param.name +'（'+ param.phonNumber +'）</div>\
														<div>地址：'+ $('.otherAds .province .cnt').html() + $('.otherAds .city .cnt').html() + $('.otherAds .area .cnt').html() + param.address +'</div>\
														<div>邮编：'+ param.postcode +'</div>\
													</div>\
												</div>\
												<div class="xwIcon pa"></div>\
											</div>\
											<div class="sbBox sub clearfix">\
												<div class="btn cancel" ontouchstart="return true">填错了</div>\
												<div class="btn sure" ontouchstart="return true">确认</div>\
											</div>\
										</div>',
								after : function(elem){
									elem.find('.cancel').click(function(){
										popPageStack();
									});
									elem.find('.sure').click(function(){
										var that = $(this);
										if (!that.hasClass('lock')) {
											that.addClass('lock');
											$.when($.get('http://www.7wenta.com/mobile/address/a.json',param,function(data){
												if (data.result.resultCode.code == 0) {
													var addressId = data.result.value.addressId;
													page.buyRealItem(goodsId,addressId,that);
												}else{
													// alert(data.result.resultCode.detail);
													that.removeClass('lock');
													navigator.alert.toast(data.result.resultCode.detail,0,function(data) {
													}, function(message) {
													});
												}
											})).fail(function(){
												that.removeClass('lock');
											});
										};
									});
								}
							});
						}
					}else{
						navigator.alert.toast('请先填写完整收货信息',0,function(data) {
						}, function(message) {
						});
					}
				});
				
				$('.shopBox').hide();
				pushPageStack({name:'address',elem:$address});
				$('.innerBody').append($address);
				$(window).scrollTop(0);
			};
		})).always(function(){
			$('.gdZone').removeClass('lock');
		}).fail(function(){
			navigator.alert.toast('请检查网络连接',0,function(data) {
			}, function(message) {
			});
		});
	},
	showSelectBox : function(type,param){
		if (type == 'province') {
			var actionUrl = 'http://www.7wenta.com/mobile/provinces.json';
			var tag = 'provinces';
			var typeName = '省份';
			var sonElem = '.city,.area';
		}else if (type == 'city'){
			var actionUrl = 'http://www.7wenta.com/mobile/cities.json';
			var tag = 'cities';
			var typeName = '城市';
			var sonElem = '.area';
		}else if (type == 'area'){
			var actionUrl = 'http://www.7wenta.com/mobile/areas.json';
			var tag = 'areas';
			var typeName = '区/县';
			var sonElem = '';
		}

		var dataList = '';
		$('.gdZone').addClass('lock');
		$.when($.get(actionUrl,param,function(data){
			if (data.result.resultCode.code == 0) {
				var value =  data.result.value[tag];
				$.each(value,function(k,v){
					dataList += '<div class="dataItm" id="'+ v.id +'" ontouchstart="return true">'+ v.name +'</div>';
				});
				$.wtBox({
					wholeCnt:'<div class="selectBox">\
								<div class="sbBox main">\
									<div class="mainWrp">\
										<div class="title">选择'+ typeName +'</div>\
										'+ (!isAndroid4?('<div class="dataList" id="scrollerWrapper"><div id="scroller">'+ dataList +'</div></div>'):('<div class="dataList" style="overflow:auto;">'+ dataList +'</div>')) +'\
									</div>\
								</div>\
							</div>',
					after : function(elem){
						elem.find('.dataItm').click(function(){
							var that = $(this);
							elem.find('.dataItm').removeClass('on');
							that.addClass('on');

							elem.data('value',{
								id : that.attr('id'),
								name : that.html()
							});

							$('.addressBox').find('.adInfo_S').each(function(){
								var that = $(this);
									if (that.attr('type') == type) {
										that.attr('id',elem.data('value').id);
										that.find('.cnt').find('.name').hide();
										that.find('.cnt').find('.value').html(elem.data('value').name).show();
									};
									if (sonElem) {
										var $sonElem = $('.addressBox').find(sonElem);
										$sonElem.removeAttr('id');
										$sonElem.find('.name').show();
										$sonElem.find('.value').html('').hide();
									};
							});
							Publisher.fire('addressCheckValid');
							popPageStack();
						});
						if (!isAndroid4) {
							(function(){
								new IScroll('#scrollerWrapper', {
									scrollbars: true,
									mouseWheel: true,
									interactiveScrollbars: true,
									shrinkScrollbars: 'scale',
									scrollbars: 'custom',
									// fadeScrollbars: true,//这个会导致android 2.3无法滚动
									click: true
								});
							})();
						};
					}
				})
			};
		})).always(function(){
			$('.gdZone').removeClass('lock');
			$('.addressBox').find('.' + type).removeClass('lock');
		}).fail(function(){
			navigator.alert.toast('请检查网络连接',0,function(data) {
			}, function(message) {
			});
		});
	},
	initShareBox : function(goodsId){
		gotoPageStack('index');
		$.wtBox({
			wholeCnt:'<div class="shareBox">\
						<div class="mainWrp">\
							<div class="shareTxt">\
				                <p>向小伙伴晒一晒礼品吧</p>\
				            </div>\
				            <div class="sp"></div>\
				            <div class="shareWrp">\
				            	<a href="javascript:;" class="sItem sqq" data-sharecode="qq">QQ</a>\
				            	<a href="javascript:;" class="sItem sqz" data-sharecode="qzone">QQ空间</a>\
				                <a href="javascript:;" class="sItem swx" data-sharecode="weixin">微信</a>\
				            </div>\
				            <div class="shareWrp">\
				                <a href="javascript:;" class="sItem spyq" data-sharecode="friend">朋友圈</a>\
				                <a href="javascript:;" class="sItem sxlwb" data-sharecode="weibo">新浪微博</a>\
				                <a href="javascript:;" class="sItemNull"></a>\
				            </div>\
						</div>\
					</div>',
			backClose : true,
			after : function(elem){
				elem.find('.sItem').click(function(){
					var index = $(this).data("sharecode");
					var url = 'http://www.7wenta.com/activity/wap/20141030/a0/index.jsp?goodsId=' + goodsId;
					var comment = '我在问他作业上赚到了'+ $('.gdItm_'+goodsId).find('.gdName').html() +'，你想要吗？解答作业题，赚取'+ $('.gdItm_'+goodsId).find('.gdName').html() +'，学霸们快来！';
					var img = $('.gdItm_'+goodsId).find('.gdImg img').data('real');
			    	var shareContent = {
			            shareKey:"wenta",// 必须
			            weixin:comment,
			            friend:comment,
			            qq:comment,
			            weibo:comment,
			            tencent:comment,
			            qzone:comment,
			            targetUrl:url,
			            imgUrl:img,
			            iconUrl:img, // 微信、朋友圈
			            otherUrl:url // 如果存在otherUrl字段，则会把该字段拼接到新浪微博和腾讯微博分享文案内容后面。此外，qq分享必须存在该字段
			        };
		 
					BtCommunication.simpleShareTo(index,shareContent);
				});
			}
		});
	},
	eventBind : function(){
		(function(eventId){
			BtPublisher.removeListen(eventId);
			BtPublisher.listen(eventId, function(cmd, status) {
				if (0 == status) {
					window.location.reload();
				} else {
					//nothing
				}
			});
		})('loginEvent');

		$('body').on('click','.dLink_wd .link_yq',function(){
			navigator.switcher.switchView(SwitchOption.SwitchTarget[5], {}, function(data) {
                // alert(data);
            }, function(message) {
                alert(message); // 输出失败消息。
            });
		});

		$('body').on('click','.dLink_wd .link_dt',function(){
			navigator.switcher.switchView(SwitchOption.SwitchTarget[2], {}, function(data) {
                // alert(data);
            }, function(message) {
                alert(message); // 输出失败消息。
            });
		});

		$('body').on('click','.dLink_nlogBtn',function(){
			BtCommunication.wapLogin(function(){
				window.location.reload();
			},function(){});
			
			navigator.commonAgent.onEvent({id:"4912"}, {
			}, function(data) {
	        }, function(message) {
	            alert(message);
	        });
		});

		$('body').on('click','.gdItm',function(){
			var parent = $(this);
			var goodsId = parent.attr('goodsId');
			var priceType = parent.attr('priceType');
			var wdb = page.data.wbdMapper[priceType];

			if (!page.data.hasLogin) {
				navigator.alert.toast('登录后才可以兑换这个奖品哦~',0,function(data) {
				}, function(message) {
				});
				BtCommunication.wapLogin(function(){
					window.location.reload();
				},function(){});
				return;
			};

			if (!$('.gdZone').hasClass('lock')) {
				$('.gdZone').addClass('lock');
				$.wtBox({
					wholeCnt:'<div class="gdBox gdBox'+ parent.attr('priceType') +' pr" goodsId="'+ goodsId +'">\
								<div class="gdImg">'+ ('<img src="'+ httpLk + 'resource/common/style/image/loading_b.png" data-real="'+ parent.attr('imgB') + '" />') +'</div>\
								<div class="gdCnt">\
									<div class="main">\
										<div class="gdName">'+ parent.find('.gdName').html() +'</div>\
										<div class="gdData clearfix">\
											<span class="gdPrice l">'+ parent.find('.gdPrice').html() +'</span>\
											<span class="gdAdopt dib clearfix l" '+ (+parent.attr('caina') == 0 ? 'style="display:none;"' : '') +'>\
												<span class="tag l">7天采纳</span>\
												<span class="num l">'+ parent.attr('caina') +'</span>\
											</span>\
										</div>\
									</div>\
									<div class="sub">\
										<div class="gdInfo wbk">'+ (parent.find('.gdDetail').html()?parent.find('.gdDetail').html():'无') +'</div>\
										<div class="gdLink">商品兑换注意事项>></div>\
									</div>\
									<div class="submitWrp"><div class="submit submit_no" ontouchstart="return true">加载中...</div></div>\
								</div>\
								<div class="close pa"></div>\
							</div>',
					after : function(elem){
						$('.gdZone').removeClass('lock');
						if ($(window).height() - elem.find('.gdBox').height() < elem.find('.close').height()) {
							elem.find('.gdInfo').css({'max-height':'3rem'});
						};
						cordovaDebug.getImg(elem.find('.gdImg img').data('real'),function(data){
							elem.find('.gdImg img').attr('src',data);
						});
						elem.find('.gdLink').click(function(){
							navigator.switcher.switchView(SwitchOption.SwitchTarget[10], {
								key_web_title : '商城兑换注意事项', 
								key_web_url : 'http://www.7wenta.com/jst/shopNoticeItems'
							}, function(data) {
								// alert(data);
							}, function(message) {
								alert(message); // 输出失败消息。
							});
						});
						elem.find('.close').click(function(){
							popPageStack();
						});
						elem.find('.submitWrp').click(function(){
							var that = $(this).find('.submit');
							var name = parent.find('.gdName').html();
							var itemTypeId = parent.attr('itemTypeId');

							if (that.hasClass('submit_no')) {
								navigator.alert.toast(that.text(),0,function(data) {
								}, function(message) {
								});
							}else if (that.hasClass('submit_no_wd') || that.hasClass('submit_no_caina')) {
								navigator.switcher.switchView(SwitchOption.SwitchTarget[2], {}, function(data) {
					                // alert(data);
					            }, function(message) {
					                alert(message); // 输出失败消息。
					            });
							}else{
								if (itemTypeId == 10) { //配送物品
									page.showAddress(goodsId);
								}else if (itemTypeId == 11 || itemTypeId == 12) { //手机充值卡
									page.showNumberBox(name,itemTypeId,goodsId);
								}else{
									if (!that.hasClass('lock')) {
										that.addClass('lock');
										page.buyDaojuItem(goodsId,that);
									};
								}
							}						
						});

						cordovaDebug.getJSON('http://www.7wenta.com/mobile/shopItem.json?goodsId=' + goodsId,function(data){
							var submitStr = '';
							if (data.result.resultCode.code == 0) {
								$('.gdItm_'+goodsId).attr('canBuy',data.result.value.shopGoods.canBuy);
								$('.gdItm_'+goodsId).attr('reason',data.result.value.shopGoods.reason);
								
								if(parent.attr('canBuy') == 'false'){
									if (page.data.daojuMapper[goodsId]) {
										submitStr = '<div class="submit submit_no" ontouchstart="return true">你已经拥有该物品了</div>';
									}else{
										submitStr = '<div class="submit submit_no" ontouchstart="return true"><p style="font-size:0.8rem;line-height:1rem;padding-top: 0.5rem;">此礼品本轮已被兑换完<span style="display:none;">,</span><br/>下次再来吧</p></div>';
									}
								}else if (+parent.find('.gdPrice').html() > +($('.dLink_'+ wdb.tag +' .dLink_tbl .wendou .num').html())) {
									submitStr = '<div class="submit submit_no_wd" ontouchstart="return true">'+ wdb.name +'不足，答题赚更多</div>';
								}else if (+parent.attr('caina') > +($('.dLink_'+ wdb.tag +' .dLink_tbl .caina .num').html())) {
									submitStr = '<div class="submit submit_no_caina" ontouchstart="return true">最近7天采纳数不足，去答题</div>';
								}else{
									submitStr = '<div class="submit" ontouchstart="return true">立即兑换</div>';
								}
							}
							elem.find('.submitWrp').html(submitStr);
						},function(){
							submitStr = '<div class="submit submit_no" ontouchstart="return true">请检查网络连接</div>';
							elem.find('.submitWrp').html(submitStr);
						});
					}
				})
			}else{
				navigator.alert.toast('请稍后，正在响应',0,function(data) {
				}, function(message) {
				});
			}
		});
	}
}

document.addEventListener("deviceready", function(){
	page.init();
}, false);

function pageChange(){
	if (page.data.pageStack[0].name == 'index') {
		$('.shopBox').show();
	};
	navigator.dataTransfer.push(DataTransferOption.DataTransferPushTarget[1], {
		isPageEnd : (page.data.pageStack[0].name == 'index')?true:false
	}, function(data) {
        // alert(data);
    }, function(message) {
        alert(message); // 输出失败消息。
    });
}
function pushPageStack(o){
	page.data.pageStack.unshift(o);
	pageChange();
}
function popPageStack(){
	page.data.pageStack[0].elem.remove();
	page.data.pageStack.shift();
	pageChange();
}
function gotoPageStack(name){
	var count = 0;
	for (var i = 0; i < page.data.pageStack.length; i++) {
		if (page.data.pageStack[i].name != name) {
			page.data.pageStack[i].elem.remove();
			count ++;
		}else{
			break;
		}
	};
	page.data.pageStack = page.data.pageStack.slice(count);
	pageChange();
}

/* 
*  客户端左上角返回按钮的js回调
*/ 
function backButtonCallback() {
	popPageStack();
}